﻿/*******************************
* автор: silin
********************************/
class Model3d extends MovieClip{
	private var vertices,faces,edges:Array;//вершины, грани,ребра
	private var fc,lc,lw,r,rx,ry,camera_z:Number;//параметры отрисовки, 'радиус', угловые скорости, удаленность камеры
	private var drag,shading,df,dl:Boolean;//флаги мыши, подсветки, отрисовки граней и ребер
	private var model,mc:String;//используемая модель(имя функции), мувик,присобачиваемый на вершины(linkage id)-если пустая строка, то ничего
	function Model3d () {
		vertices = [];faces = [];edges = [];
		this[model]();//определяем  модель
		if(mc!='')for(var i=vertices.length;i--;) attachMovie(mc,i,i);//аттачим мувики по числу вершин, если задано
		render();//на случай если rx и ry заданы как 0
		onEnterFrame=function(){
			if (this.drag){//смотрим куда тащит мышь
				this.rx = 2 * (this._ymouse - this.y) / this._height;
				this.ry = 2 * (this._xmouse - this.x) / this._width;
				this.x = this._xmouse;
				this.y = this._ymouse;
			}/*else{//замедляем
				this.rx*=0.995;
				this.ry*=0.995;
			}*/
			if(this.rx||this.ry)this.render ();//если надо(есть поворот), то считаем/рисуем
		}
		onPress = function (){
			this.x = this._xmouse;
			this.y = this._ymouse;
			this.drag = true;
		}
		onRelease = this.onReleaseOutside = function (){
			this.drag = false;
		}
	}

	//////////////////////////////////////////////////////////////////
	private function drawFaces (){//отрисовка граней
		clear ();
		if (dl) lineStyle (lw, lc);
		for (var i =  faces.length;i--;){
			var f = faces [i];
			if ((f [1].sx - f [0].sx) * (f [2].sy - f [1].sy) - (f [1].sy - f [0].sy) * (f [2].sx - f [1].sx) > 0){//условие видимости грани
				for (var j = f.length, z = 0;j -- ;) z += f [j].z;
				z /= f.length * r;//средняя z-координата (для 'подсветки')
				beginFill(shading?depthColor(fc,z-1):fc);
				moveTo (f [0].sx, f [0].sy)
				for (var k = f.length;--k ;) lineTo (f [k].sx, f [k].sy)
				endFill ()
			}
		}
	}
	//////////////////////////////////////////////////////////////////
	private function drawEdges (){//отрисовка ребер
		clear ();
		lineStyle (lw, lc);
		for (var i = edges.length;i--;)	{
			var e = edges [i];
			moveTo (e [0].sx, e [0].sy);
			for (var k =1,l=e.length;k< l;k++) lineTo (e [k].sx, e [k].sy);
		}
	}
	///////////////////////////////////////////////////////////////
	private function render(){//расчет и отрисовка
		for (var i = vertices.length,sax = Math.sin (rx),cax = Math.cos (rx),say = Math.sin (ry),cay = Math.cos (ry);i-- ;){
			var v = vertices [i],tx = v.y,ty=v.x;
			v.y = v.y * cax + v.z * sax;
			v.z = v.z * cax - tx * sax;
			v.x = v.x * cay + v.z * say;
			v.z = v.z * cay - ty * say;
			var d = camera_z / (camera_z - v.z);
			v.d = d;
			v.sx = v.x * d;
			v.sy = v.y * d;
		}
		if (df) drawFaces ();else if (dl) drawEdges ();//что рисовать
		if(this[0]) for(var i=vertices.length;i--;){//если определены мувики на вершинах, ставим их по местам
			var v=vertices[i],c=this[i];
			c._x=v.sx;c._y=v.sy;
			c._xscale=c._yscale=100*v.d;
			c.swapDepths(1000*v.d)
		}
	}
	/////////////////////////////////////////////////////////////
	private function depthColor (col, n){//усугубляет цвет
		var ca = [] , cs = col.toString (16);
		while (cs.length < 6) cs = "0" + cs;
		for (var j = 0;	j < 3;j ++){
			var rc = parseInt (cs.toString (16).substr (j * 2, 2) , 16)
			ca.push (Math.floor (n > 0 ? n * 255 + (1 - n) * rc : (1 + n) * rc ))
		}
		return ca [0] << 16 | ca [1] << 8 | ca [2]
	}
	/////////////////////////////////////////////////////////////////////
	private function addVertex (xx, yy, zz){
		vertices.push ({x : xx, y : yy, z : zz});
	}
	//////////////////////////////////////////////////////////////////
	private function addEdge (){
		for (var k = arguments.length,tmp = [];k--;) tmp [k] = vertices [arguments [k]];
		edges.push (tmp);
	}
	//////////////////////////////////////////////////////////////////
	private function addFace (){
		for (var k = arguments.length,tmp = [];k--;) tmp [k] = vertices [arguments [k]];
		faces.push (tmp);
	}
	//////////модельки//////////////////////////////////////////////////
	private function cub() {
		addVertex (r, r, r);
		addVertex (r, r, - r);
		addVertex (r, - r, - r);
		addVertex (r, - r, r);
		addVertex ( - r, r, r);
		addVertex ( - r, r, - r);
		addVertex ( - r, - r, - r);
		addVertex ( - r, - r, r);
		addEdge (0, 3, 7, 4, 5, 6, 2, 1, 0);
		addEdge (0, 4);
		addEdge (1, 5);
		addEdge (2, 3);
		addEdge (6, 7);
		addFace (1, 0, 3, 2);
		addFace (5, 1, 2, 6);
		addFace (4, 5, 6, 7);
		addFace (0, 4, 7, 3);
		addFace (4, 0, 1, 5);
		addFace (2, 3, 7, 6);
	}
	private function tet() {
		addVertex (0, 2.31 * r, 1.633 * r);
		addVertex (0, - 2.31 * r, 1.633 * r);
		addVertex (2.31 * r, 0, - 1.633 * r);
		addVertex ( - 2.31 * r, 0, - 1.633 * r)
		addEdge (0, 1, 2, 3, 1);
		addEdge (0, 2);
		addEdge (0, 3);
		addFace (1, 2, 0);
		addFace (2, 3, 0);
		addFace (3, 1, 0);
		addFace (3, 2, 1);
	}
	private function oct() {
		addVertex (0, 0, 1.4142*r);
		addVertex (r, r, 0);
		addVertex (-r,r, 0);
		addVertex ( -r,-r,0);
		addVertex (r,-r, 0);
		addVertex (0, 0, - 1.4142*r);
		addEdge (0, 1, 5, 3, 0, 4, 5, 2, 0);
		addEdge (1, 2, 3, 4, 1);
		addFace (0, 4, 1);
		addFace (1, 5, 2);
		addFace (2, 3, 0);
		addFace (3, 5, 4);
		addFace (1, 2, 0);
		addFace (3, 4, 0);
		addFace (4, 5, 1);
		addFace (3, 2, 5);
	}
	private function sph() {
		addVertex(0.270598*r,-0.92388*r,-0.270598*r);
		addVertex(0*r,-0.92388*r,-0.382683*r);
		addVertex(-0.270598*r,-0.92388*r,-0.270598*r);
		addVertex(-0.382683*r,-0.92388*r,0*r);
		addVertex(-0.270598*r,-0.92388*r,0.270598*r);
		addVertex(0*r,-0.92388*r,0.382683*r);
		addVertex(0.270598*r,-0.92388*r,0.270598*r);
		addVertex(0.382683*r,-0.92388*r,0*r);
		addVertex(0.5*r,-0.707107*r,-0.5*r);
		addVertex(0*r,-0.707107*r,-0.707107*r);
		addVertex(-0.5*r,-0.707107*r,-0.5*r);
		addVertex(-0.707107*r,-0.707107*r,0*r);
		addVertex(-0.5*r,-0.707107*r,0.5*r);
		addVertex(0*r,-0.707107*r,0.707107*r);
		addVertex(0.5*r,-0.707107*r,0.5*r);
		addVertex(0.707107*r,-0.707107*r,0*r);
		addVertex(0.653281*r,-0.382683*r,-0.653281*r);
		addVertex(0*r,-0.382683*r,-0.923879*r);
		addVertex(-0.653281*r,-0.382683*r,-0.653281*r);
		addVertex(-0.923879*r,-0.382683*r,0*r);
		addVertex(-0.653281*r,-0.382683*r,0.653281*r);
		addVertex(0*r,-0.382683*r,0.923879*r);
		addVertex(0.653281*r,-0.382683*r,0.653281*r);
		addVertex(0.92388*r,-0.382683*r,0*r);
		addVertex(0.707107*r,0*r,-0.707107*r);
		addVertex(0*r,0*r,-1*r);
		addVertex(-0.707107*r,0*r,-0.707107*r);
		addVertex(-1*r,0*r,0*r);
		addVertex(-0.707107*r,0*r,0.707107*r);
		addVertex(0*r,0*r,1*r);
		addVertex(0.707107*r,0*r,0.707107*r);
		addVertex(1*r,0*r,0*r);
		addVertex(0.653281*r,0.382683*r,-0.653281*r);
		addVertex(0*r,0.382683*r,-0.923879*r);
		addVertex(-0.653281*r,0.382683*r,-0.653281*r);
		addVertex(-0.923879*r,0.382683*r,0*r);
		addVertex(-0.653281*r,0.382683*r,0.653281*r);
		addVertex(0*r,0.382683*r,0.923879*r);
		addVertex(0.653281*r,0.382683*r,0.653281*r);
		addVertex(0.92388*r,0.382683*r,0*r);
		addVertex(0.5*r,0.707107*r,-0.5*r);
		addVertex(0*r,0.707107*r,-0.707107*r);
		addVertex(-0.5*r,0.707107*r,-0.5*r);
		addVertex(-0.707107*r,0.707107*r,0*r);
		addVertex(-0.5*r,0.707107*r,0.5*r);
		addVertex(0*r,0.707107*r,0.707107*r);
		addVertex(0.5*r,0.707107*r,0.5*r);
		addVertex(0.707107*r,0.707107*r,0*r);
		addVertex(0.270598*r,0.92388*r,-0.270598*r);
		addVertex(0*r,0.92388*r,-0.382683*r);
		addVertex(-0.270598*r,0.92388*r,-0.270598*r);
		addVertex(-0.382683*r,0.92388*r,0*r);
		addVertex(-0.270598*r,0.92388*r,0.270598*r);
		addVertex(0*r,0.92388*r,0.382683*r);
		addVertex(0.270598*r,0.92388*r,0.270598*r);
		addVertex(0.382683*r,0.92388*r,0*r);
		addVertex(0*r,-1*r,0*r);
		addVertex(0*r,1*r,0*r);
		addEdge(8,9,10,11,12,13,14,15,8);
		addEdge(16,17,18,19,20,21,22,23,16);
		addEdge(24,25,26,27,28,29,30,31,24);
		addEdge(32,33,34,35,36,37,38,39,32);
		addEdge(40,41,42,43,44,45,46,47,40);
		addEdge(56,1,9,17,25,33,41,49,57,48,55,54,53,52,51,50,49,48,40,32,24,16,8,0,7,6,5,4,3,2,1,0,56);
		addEdge(56,3,11,19,27,35,43,51,57,50,42,34,26,18,10,2,56);
		addEdge(56,5,13,21,29,37,45,53,57,52,44,36,28,20,12,4,56);
		addEdge(56,7,15,23,31,39,47,55,57,54,46,38,30,22,14,6,56);
		 addFace(0,1,9,8);
		 addFace(1,2,10,9);
		 addFace(2,3,11,10);
		 addFace(3,4,12,11);
		 addFace(4,5,13,12);
		 addFace(5,6,14,13);
		 addFace(6,7,15,14);
		 addFace(7,0,8,15);
		 addFace(8,9,17,16);
		 addFace(9,10,18,17);
		 addFace(10,11,19,18);
		 addFace(11,12,20,19);
		 addFace(12,13,21,20);
		 addFace(13,14,22,21);
		 addFace(14,15,23,22);
		 addFace(15,8,16,23);
		 addFace(16,17,25,24);
		 addFace(17,18,26,25);
		 addFace(18,19,27,26);
		 addFace(19,20,28,27);
		 addFace(20,21,29,28);
		 addFace(21,22,30,29);
		 addFace(22,23,31,30);
		 addFace(23,16,24,31);
		 addFace(24,25,33,32);
		 addFace(25,26,34,33);
		 addFace(26,27,35,34);
		 addFace(27,28,36,35);
		 addFace(28,29,37,36);
		 addFace(29,30,38,37);
		 addFace(30,31,39,38);
		 addFace(31,24,32,39);
		 addFace(32,33,41,40);
		 addFace(33,34,42,41);
		 addFace(34,35,43,42);
		 addFace(35,36,44,43);
		 addFace(36,37,45,44);
		 addFace(37,38,46,45);
		 addFace(38,39,47,46);
		 addFace(39,32,40,47);
		 addFace(40,41,49,48);
		 addFace(41,42,50,49);
		 addFace(42,43,51,50);
		 addFace(43,44,52,51);
		 addFace(44,45,53,52);
		 addFace(45,46,54,53);
		 addFace(46,47,55,54);
		 addFace(47,40,48,55);
		 addFace(1,0,56);
		 addFace(2,1,56);
		 addFace(3,2,56);
		 addFace(4,3,56);
		 addFace(5,4,56);
		 addFace(6,5,56);
		 addFace(7,6,56);
		 addFace(0,7,56);
		 addFace(48,49,57);
		 addFace(49,50,57);
		 addFace(50,51,57);
		 addFace(51,52,57);
		 addFace(52,53,57);
		 addFace(53,54,57);
		 addFace(54,55,57);
		 addFace(55,48,57);
	}

}
